def f1(number : Int) : Int = {
  if (number == 1) throw new RuntimeException()
  1 * f1(number - 1)
}

try {
  println("Simple recursion")
  f1(5)
} catch {
  case ex => ex.printStackTrace() // see the number of levels of stack
}

@scala.annotation.tailrec
def f2(number : Int) : Int = {
  if (number == 1) throw new RuntimeException()
  f2(number - 1)
}

try {
  println("Tail recursion")
  f2(5)
} catch {
  case ex => ex.printStackTrace() // see the number of levels of stack
}