(declare produce consume)

(defn produce [n, produced]
  (if (= n 0)
    produced
    (consume n (+ produced 1))))

(defn consume [n, produced]
  (if (= n 0)
    0
    (produce (- n 1) produced)))

(try
  (produce 100000 0)
  (catch StackOverflowError ex (println ex)))    

(declare produce1 consume1)

(defn produce1 [n, produced]
  (if (= n 0)
    produced
    #(consume1 n (+ produced 1))))

(defn consume1 [n, produced]
  (if (= n 0)
    0
    #(produce1 (- n 1) produced)))

(println (trampoline (produce1 100000 0)))